import { AfterContentInit, ElementRef, EventEmitter, OnDestroy, Renderer } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { Config } from '../../config/config';
import { Ion } from '../ion';
import { Item } from '../item/item';
import { ToggleGesture } from './toggle-gesture';
import { GestureController } from '../../gestures/gesture-controller';
import { Haptic } from '../../util/haptic';
import { Form, IonicTapInput } from '../../util/form';
import { DomController } from '../../util/dom-controller';
export declare const TOGGLE_VALUE_ACCESSOR: any;
export declare class Toggle extends Ion implements IonicTapInput, AfterContentInit, ControlValueAccessor, OnDestroy {
    _form: Form;
    private _haptic;
    _item: Item;
    private _gestureCtrl;
    private _domCtrl;
    _checked: boolean;
    _init: boolean;
    _disabled: boolean;
    _labelId: string;
    _activated: boolean;
    _startX: number;
    _msPrv: number;
    _fn: Function;
    _gesture: ToggleGesture;
    id: string;
    color: string;
    mode: string;
    ionChange: EventEmitter<Toggle>;
    constructor(_form: Form, config: Config, elementRef: ElementRef, renderer: Renderer, _haptic: Haptic, _item: Item, _gestureCtrl: GestureController, _domCtrl: DomController);
    ngAfterContentInit(): void;
    _onDragStart(startX: number): void;
    _onDragMove(currentX: number): void;
    _onDragEnd(endX: number): void;
    checked: boolean;
    _setChecked(isChecked: boolean): void;
    writeValue(val: any): void;
    registerOnChange(fn: Function): void;
    registerOnTouched(fn: any): void;
    disabled: boolean;
    onChange(isChecked: boolean): void;
    onTouched(): void;
    _keyup(ev: KeyboardEvent): void;
    initFocus(): void;
    ngOnDestroy(): void;
}
